function [residual, g1, g2, g3] = usmodelzlb_dynamic(y, x, params, steady_state, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(45, 1);
T21 = 1/(params(10)/(1-params(10)));
T37 = 1/(1+params(41)*params(39));
T45 = 1/(params(39)^2*params(12));
T57 = params(15)/params(39);
T62 = (1-T57)/(params(14)*(1+T57));
T74 = (1-params(13))/(params(44)+1-params(13));
T90 = (params(14)-1)*params(53)/(params(14)*(1+T57));
T120 = 1/(1-T57);
T123 = T57/(1-T57);
T212 = 1/(1+params(41)*params(39)*params(19));
T227 = (1-params(20))*(1-params(41)*params(39)*params(20))/params(20)/(1+(params(16)-1)*params(3));
T236 = params(41)*params(39)/(1+params(41)*params(39));
T264 = (1-params(18))*(1-params(41)*params(39)*params(18))/((1+params(41)*params(39))*params(18))*1/(1+(params(22)-1)*params(1));
lhs =y(55);
rhs =params(9)*y(34)+(1-params(9))*y(41);
residual(1)= lhs-rhs;
lhs =y(33);
rhs =y(34)*T21;
residual(2)= lhs-rhs;
lhs =y(34);
rhs =y(41)+y(40)-y(35);
residual(3)= lhs-rhs;
lhs =y(35);
rhs =y(33)+y(19);
residual(4)= lhs-rhs;
lhs =y(38);
rhs =T37*(y(4)+params(41)*params(39)*y(72)+T45*y(36))+y(58);
residual(5)= lhs-rhs;
lhs =y(36);
rhs =(-y(42))+y(56)*1/T62+params(44)/(params(44)+1-params(13))*y(69)+T74*y(70);
residual(6)= lhs-rhs;
lhs =y(37);
rhs =y(56)+T57/(1+T57)*y(3)+1/(1+T57)*y(71)+T90*(y(40)-y(73))-y(42)*T62;
residual(7)= lhs-rhs;
lhs =y(39);
rhs =y(37)*params(51)+y(38)*params(50)+y(57)+y(33)*params(52);
residual(8)= lhs-rhs;
lhs =y(39);
rhs =params(16)*(y(55)+params(9)*y(35)+(1-params(9))*y(40));
residual(9)= lhs-rhs;
lhs =y(41);
rhs =y(40)*params(21)+y(37)*T120-y(3)*T123;
residual(10)= lhs-rhs;
lhs =y(62);
rhs =y(19)*(1-params(46))+y(38)*params(46)+y(58)*params(39)^2*params(12)*params(46);
residual(11)= lhs-rhs;
lhs =y(43);
rhs =params(9)*y(45)+(1-params(9))*y(53)-y(55);
residual(12)= lhs-rhs;
lhs =y(44);
rhs =T21*y(45);
residual(13)= lhs-rhs;
lhs =y(45);
rhs =y(53)+y(51)-y(46);
residual(14)= lhs-rhs;
lhs =y(46);
rhs =y(44)+y(20);
residual(15)= lhs-rhs;
lhs =y(49);
rhs =y(58)+T37*(y(7)+params(41)*params(39)*y(77)+T45*y(47));
residual(16)= lhs-rhs;
lhs =y(47);
rhs =y(56)*1/T62+(-y(54))+y(79)+params(44)/(params(44)+1-params(13))*y(74)+T74*y(75);
residual(17)= lhs-rhs;
lhs =y(48);
rhs =y(56)+T57/(1+T57)*y(6)+1/(1+T57)*y(76)+T90*(y(51)-y(78))-T62*(y(54)-y(79));
residual(18)= lhs-rhs;
lhs =y(50);
rhs =y(57)+params(51)*y(48)+params(50)*y(49)+params(52)*y(44);
residual(19)= lhs-rhs;
lhs =y(50);
rhs =params(16)*(y(55)+params(9)*y(46)+(1-params(9))*y(51));
residual(20)= lhs-rhs;
lhs =y(52);
rhs =T212*(params(41)*params(39)*y(79)+params(19)*y(9)+y(43)*T227)+y(60);
residual(21)= lhs-rhs;
lhs =y(53);
rhs =T37*y(10)+T236*y(80)+y(9)*params(17)/(1+params(41)*params(39))-y(52)*(1+params(41)*params(39)*params(17))/(1+params(41)*params(39))+y(79)*T236+T264*(params(21)*y(51)+T120*y(48)-T123*y(6)-y(53))+y(61);
residual(22)= lhs-rhs;
lhs =y(64);
rhs =y(52)*params(23)*(1-params(26))+(1-params(26))*params(25)*(y(50)-y(39))+params(24)*(y(50)-y(39)-y(8)+y(5))+params(26)*y(11)+y(59)+y(65);
residual(23)= lhs-rhs;
lhs =y(54);
rhs =(-params(37));
residual(24)= lhs-rhs;
lhs =y(55);
rhs =params(27)*y(12)+x(it_, 1);
residual(25)= lhs-rhs;
lhs =y(56);
rhs =params(29)*y(13)+x(it_, 2);
residual(26)= lhs-rhs;
lhs =y(57);
rhs =params(30)*y(14)+x(it_, 3)+x(it_, 1)*params(2);
residual(27)= lhs-rhs;
lhs =y(58);
rhs =params(32)*y(15)+x(it_, 4);
residual(28)= lhs-rhs;
lhs =y(59);
rhs =params(33)*y(16)+x(it_, 5);
residual(29)= lhs-rhs;
lhs =y(60);
rhs =params(34)*y(17)+y(32)-params(8)*y(2);
residual(30)= lhs-rhs;
lhs =y(32);
rhs =x(it_, 6);
residual(31)= lhs-rhs;
lhs =y(61);
rhs =params(35)*y(18)+y(31)-params(7)*y(1);
residual(32)= lhs-rhs;
lhs =y(31);
rhs =x(it_, 7);
residual(33)= lhs-rhs;
lhs =y(63);
rhs =(1-params(46))*y(20)+params(46)*y(49)+y(58)*params(12)*params(39)^2*params(46);
residual(34)= lhs-rhs;
lhs =y(27);
rhs =y(50)-y(8)+params(36);
residual(35)= lhs-rhs;
lhs =y(28);
rhs =params(36)+y(48)-y(6);
residual(36)= lhs-rhs;
lhs =y(29);
rhs =params(36)+y(49)-y(7);
residual(37)= lhs-rhs;
lhs =y(30);
rhs =params(36)+y(53)-y(10);
residual(38)= lhs-rhs;
lhs =y(26);
rhs =y(52)+params(5);
residual(39)= lhs-rhs;
lhs =y(25);
rhs =y(54)+params(37);
residual(40)= lhs-rhs;
lhs =y(24);
rhs =y(51)+params(4);
residual(41)= lhs-rhs;
lhs =y(65);
rhs =y(21)+x(it_, 8);
residual(42)= lhs-rhs;
lhs =y(66);
rhs =y(22)+x(it_, 9);
residual(43)= lhs-rhs;
lhs =y(67);
rhs =y(23)+x(it_, 10);
residual(44)= lhs-rhs;
lhs =y(68);
rhs =x(it_, 11);
residual(45)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(45, 91);

  %
  % Jacobian matrix
  %

  g1(1,34)=(-params(9));
  g1(1,41)=(-(1-params(9)));
  g1(1,55)=1;
  g1(2,33)=1;
  g1(2,34)=(-T21);
  g1(3,34)=1;
  g1(3,35)=1;
  g1(3,40)=(-1);
  g1(3,41)=(-1);
  g1(4,33)=(-1);
  g1(4,35)=1;
  g1(4,19)=(-1);
  g1(5,36)=(-(T37*T45));
  g1(5,4)=(-T37);
  g1(5,38)=1;
  g1(5,72)=(-(params(41)*params(39)*T37));
  g1(5,58)=(-1);
  g1(6,69)=(-(params(44)/(params(44)+1-params(13))));
  g1(6,36)=1;
  g1(6,70)=(-T74);
  g1(6,42)=1;
  g1(6,56)=(-(1/T62));
  g1(7,3)=(-(T57/(1+T57)));
  g1(7,37)=1;
  g1(7,71)=(-(1/(1+T57)));
  g1(7,40)=(-T90);
  g1(7,73)=T90;
  g1(7,42)=T62;
  g1(7,56)=(-1);
  g1(8,33)=(-params(52));
  g1(8,37)=(-params(51));
  g1(8,38)=(-params(50));
  g1(8,39)=1;
  g1(8,57)=(-1);
  g1(9,35)=(-(params(9)*params(16)));
  g1(9,39)=1;
  g1(9,40)=(-((1-params(9))*params(16)));
  g1(9,55)=(-params(16));
  g1(10,3)=T123;
  g1(10,37)=(-T120);
  g1(10,40)=(-params(21));
  g1(10,41)=1;
  g1(11,38)=(-params(46));
  g1(11,58)=(-(params(39)^2*params(12)*params(46)));
  g1(11,19)=(-(1-params(46)));
  g1(11,62)=1;
  g1(12,43)=1;
  g1(12,45)=(-params(9));
  g1(12,53)=(-(1-params(9)));
  g1(12,55)=1;
  g1(13,44)=1;
  g1(13,45)=(-T21);
  g1(14,45)=1;
  g1(14,46)=1;
  g1(14,51)=(-1);
  g1(14,53)=(-1);
  g1(15,44)=(-1);
  g1(15,46)=1;
  g1(15,20)=(-1);
  g1(16,47)=(-(T37*T45));
  g1(16,7)=(-T37);
  g1(16,49)=1;
  g1(16,77)=(-(params(41)*params(39)*T37));
  g1(16,58)=(-1);
  g1(17,74)=(-(params(44)/(params(44)+1-params(13))));
  g1(17,47)=1;
  g1(17,75)=(-T74);
  g1(17,79)=(-1);
  g1(17,54)=1;
  g1(17,56)=(-(1/T62));
  g1(18,6)=(-(T57/(1+T57)));
  g1(18,48)=1;
  g1(18,76)=(-(1/(1+T57)));
  g1(18,51)=(-T90);
  g1(18,78)=T90;
  g1(18,79)=(-T62);
  g1(18,54)=T62;
  g1(18,56)=(-1);
  g1(19,44)=(-params(52));
  g1(19,48)=(-params(51));
  g1(19,49)=(-params(50));
  g1(19,50)=1;
  g1(19,57)=(-1);
  g1(20,46)=(-(params(9)*params(16)));
  g1(20,50)=1;
  g1(20,51)=(-((1-params(9))*params(16)));
  g1(20,55)=(-params(16));
  g1(21,43)=(-(T212*T227));
  g1(21,9)=(-(params(19)*T212));
  g1(21,52)=1;
  g1(21,79)=(-(params(41)*params(39)*T212));
  g1(21,60)=(-1);
  g1(22,6)=(-(T264*(-T123)));
  g1(22,48)=(-(T120*T264));
  g1(22,51)=(-(params(21)*T264));
  g1(22,9)=(-(params(17)/(1+params(41)*params(39))));
  g1(22,52)=(1+params(41)*params(39)*params(17))/(1+params(41)*params(39));
  g1(22,79)=(-T236);
  g1(22,10)=(-T37);
  g1(22,53)=1-(-T264);
  g1(22,80)=(-T236);
  g1(22,61)=(-1);
  g1(23,5)=(-params(24));
  g1(23,39)=(-((-((1-params(26))*params(25)))-params(24)));
  g1(23,8)=params(24);
  g1(23,50)=(-((1-params(26))*params(25)+params(24)));
  g1(23,52)=(-(params(23)*(1-params(26))));
  g1(23,11)=(-params(26));
  g1(23,59)=(-1);
  g1(23,64)=1;
  g1(23,65)=(-1);
  g1(24,54)=1;
  g1(25,12)=(-params(27));
  g1(25,55)=1;
  g1(25,81)=(-1);
  g1(26,13)=(-params(29));
  g1(26,56)=1;
  g1(26,82)=(-1);
  g1(27,14)=(-params(30));
  g1(27,57)=1;
  g1(27,81)=(-params(2));
  g1(27,83)=(-1);
  g1(28,15)=(-params(32));
  g1(28,58)=1;
  g1(28,84)=(-1);
  g1(29,16)=(-params(33));
  g1(29,59)=1;
  g1(29,85)=(-1);
  g1(30,2)=params(8);
  g1(30,32)=(-1);
  g1(30,17)=(-params(34));
  g1(30,60)=1;
  g1(31,32)=1;
  g1(31,86)=(-1);
  g1(32,1)=params(7);
  g1(32,31)=(-1);
  g1(32,18)=(-params(35));
  g1(32,61)=1;
  g1(33,31)=1;
  g1(33,87)=(-1);
  g1(34,49)=(-params(46));
  g1(34,58)=(-(params(12)*params(39)^2*params(46)));
  g1(34,20)=(-(1-params(46)));
  g1(34,63)=1;
  g1(35,27)=1;
  g1(35,8)=1;
  g1(35,50)=(-1);
  g1(36,28)=1;
  g1(36,6)=1;
  g1(36,48)=(-1);
  g1(37,29)=1;
  g1(37,7)=1;
  g1(37,49)=(-1);
  g1(38,30)=1;
  g1(38,10)=1;
  g1(38,53)=(-1);
  g1(39,26)=1;
  g1(39,52)=(-1);
  g1(40,25)=1;
  g1(40,54)=(-1);
  g1(41,24)=1;
  g1(41,51)=(-1);
  g1(42,65)=1;
  g1(42,21)=(-1);
  g1(42,88)=(-1);
  g1(43,66)=1;
  g1(43,22)=(-1);
  g1(43,89)=(-1);
  g1(44,67)=1;
  g1(44,23)=(-1);
  g1(44,90)=(-1);
  g1(45,68)=1;
  g1(45,91)=(-1);
end
if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],45,8281);
end
if nargout >= 4,
  %
  % Third order derivatives
  %

  g3 = sparse([],[],[],45,753571);
end
end
