function [residual, g1, g2, g3] = cgg_zlb_dynamic(y, x, params, steady_state, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(10, 1);
lhs =y(12);
rhs =y(17)-params(6)*(y(9)-y(14))+y(6);
residual(1)= lhs-rhs;
lhs =y(7);
rhs =y(14)*params(1)+y(12)*params(5)+x(it_, 1);
residual(2)= lhs-rhs;
lhs =y(6);
rhs =params(7)*y(2)+x(it_, 3);
residual(3)= lhs-rhs;
lhs =y(5);
rhs =params(8)*y(1)+x(it_, 2);
residual(4)= lhs-rhs;
lhs =y(4);
rhs =x(it_, 1);
residual(5)= lhs-rhs;
lhs =y(10);
rhs =y(9)*0.10+0.90*y(16);
residual(6)= lhs-rhs;
lhs =y(9);
rhs =(-(1/params(1)-1));
residual(7)= lhs-rhs;
lhs =y(11);
rhs =y(5)+params(4)*y(3)+(1-params(4))*(params(2)*y(8)+params(3)*y(13));
residual(8)= lhs-rhs;
lhs =y(13);
rhs =y(6)+y(18)-params(6)*(y(11)-y(15));
residual(9)= lhs-rhs;
lhs =y(8);
rhs =x(it_, 1)+params(1)*y(15)+params(5)*y(13);
residual(10)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(10, 21);

  %
  % Jacobian matrix
  %

  g1(1,6)=(-1);
  g1(1,14)=(-params(6));
  g1(1,9)=params(6);
  g1(1,12)=1;
  g1(1,17)=(-1);
  g1(2,7)=1;
  g1(2,14)=(-params(1));
  g1(2,12)=(-params(5));
  g1(2,19)=(-1);
  g1(3,2)=(-params(7));
  g1(3,6)=1;
  g1(3,21)=(-1);
  g1(4,1)=(-params(8));
  g1(4,5)=1;
  g1(4,20)=(-1);
  g1(5,4)=1;
  g1(5,19)=(-1);
  g1(6,9)=(-0.10);
  g1(6,10)=1;
  g1(6,16)=(-0.90);
  g1(7,9)=1;
  g1(8,5)=(-1);
  g1(8,8)=(-((1-params(4))*params(2)));
  g1(8,3)=(-params(4));
  g1(8,11)=1;
  g1(8,13)=(-((1-params(4))*params(3)));
  g1(9,6)=(-1);
  g1(9,15)=(-params(6));
  g1(9,11)=params(6);
  g1(9,13)=1;
  g1(9,18)=(-1);
  g1(10,8)=1;
  g1(10,15)=(-params(1));
  g1(10,13)=(-params(5));
  g1(10,19)=(-1);
end
if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],10,441);
end
if nargout >= 4,
  %
  % Third order derivatives
  %

  g3 = sparse([],[],[],10,9261);
end
end
